﻿using FlowAlert.Model;
using log4net;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Quartz;
using RDIFramework.Utilities;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Web.Security;

namespace TimedUpload.QuartzJobs
{
    public class DataUploadJob : IJob
    {
        private readonly ILog log = LogManager.GetLogger(typeof(DataUploadJob));
        private static DateTime timeStampStartTime = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);


        static IDbProvider dbHelper
        {
            get
            {
                var DbDefine = DbFactoryProvider.GetProvider(CurrentDbType.SqlServer, Config.GetValue("DbConn"));
                return DbDefine;
            }
        }

        public void Execute(IJobExecutionContext context)
        {
            try
            {

                UploadDataInfo();


            }
            catch (Exception ex)
            {
                log.Error("上传数据错误:" + ex.Message);
            }
        }
        /// <summary>
        /// 上传数据
        /// </summary>
        public void UploadDataInfo()
        {
            String result;

            try
            {
                //CONVERT([int], [表读数])
                StringBuilder stb = new StringBuilder();
                String sql = "select * from dbo.V_WaterMeters where NowReading is not null  and CompanyID='" + SystemConfig.CompanyId + "'";
            
                DataTable dt = dbHelper.Fill(sql);
                if (dt != null && dt.Rows.Count > 0)
                {
                    int num = 0;
                    int i = 0;
                   
                    log.Debug("~~~~~~~~~~~开始上传数据~~~~~~~~~~~~~");
                    foreach (DataRow row in dt.Rows) 
                    {
                        i += 1;
                        StringBuilder dataStb = new StringBuilder();
                        stb.Clear();
                        stb.Append("{ \"auto\":{");
                        stb.Append("\"client_time\":" + getTimeStamp(DateTime.Now) +",");
                        stb.Append("\"uuid\":\"" + Guid.NewGuid().ToString() + "\",");
                        stb.Append("\"cc\":\"山东微维\",");
                        stb.Append("\"cv\":\"NB-IOT\",");
                        stb.Append("\"proi\":\"NB-IOT\",");
                        stb.Append("\"osversion\":\"\",");
                        stb.Append("\"conn\":\"\",");

                        stb.Append("\"client_ip\":\"\"");
                        stb.Append("},");
                        stb.Append("\"business\":\"REPORT_PROPERTY\",");
                        stb.Append("\"business_info\":");
                        stb.Append("{");
                        stb.Append("\"CurrentNumber\":\"" + row["NowReading"] + "\",");
                        stb.Append("\"currentForwardFlow\":\"" + row["Total_up"] +"\",");
                        stb.Append("\"currentReverseFlow\":\"" + row["Total_down"] + "\",");
                        stb.Append("\"timestamp\":" + getTimeStamp10(Convert.ToDateTime(row["NowRadingDT"])) +",");
                        stb.Append("\"Shuibiao_SN\":\"" + row["ElecAddress"] +"\",");  
                        stb.Append("\"companyId\":\"08\",");
                        stb.Append("\"ICCID\":\""+row["ICCID"]+"\",");
                        stb.Append("\"CSQ\":\""+row["Rsrp"]+"\",");
                        stb.Append("\"NB_IMEI\":\""+row["IMEI"]+"\",");

                        
                        stb.Append("\"operators\":\"CTCC\",");
                    //    stb.Append("\"CurrentVoltage\":\""+row["BatteryVoltage"])/100*3.6 +"\",");
                        stb.Append("\"temperature\":\"\"");
                        stb.Append("}");
                        stb.Append("}");
                        result = postSend(Config.GetValue("UploadDataUrl"), stb.ToString());
                        log.Debug("结果："+ row["ElecAddress"] +","+result);
                        
                        var dicRes = JsonConvert.DeserializeObject<Result>(result);
                        if (dicRes !=null)
                        {
                            if (dicRes.state=="0")
                            {

                                log.Debug(row["ElecAddress"] + "上传成功" );
                                num += 1;
                            
                            }
                            else
                            {
                                log.Debug(row["ElecAddress"] + "上传失败");
                              
                            }
                        }
                        if (i==dt.Rows.Count)
                        {
                            
                            log.Debug(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "','总共" + dt.Rows.Count + "条,成功上传" + num + "条");
                        }
                       

                    }
                    Config.SetValue("uploadTime",DateTime.Now.ToString("yyyy-MM-dd HH:mm"));

                }

            }
            catch (Exception ex)
            {

                log.Debug("上传数据失败:" + ex.ToString());
            }


        }
    
        #region 请求接口
        /// <summary>
        /// 
        /// </summary>
        /// <param name="url"></param>
        /// <param name="param"></param>
        /// <param name="type"></param>
        /// <param name="webHeader">请求头携带请求权限</param>
        /// <returns></returns>
        public string postSend(string url, string param, String type = "POST")
        {
            string strResult = "";
            Encoding myEncode = Encoding.GetEncoding("UTF-8");
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(url);
            req.Method = type;
            req.ContentType = "application/json; charset=utf-8";
          
            

            if (param != null)
            {
                byte[] postBytes = Encoding.UTF8.GetBytes(param);
                req.ContentLength = postBytes.Length;
                using (Stream reqStream = req.GetRequestStream())
                {
                    reqStream.Write(postBytes, 0, postBytes.Length);
                }
            }


            try
            {

                using (WebResponse res = req.GetResponse())
                {
                    using (StreamReader sr = new StreamReader(res.GetResponseStream(), myEncode))
                    {
                        strResult = sr.ReadToEnd();
                        return strResult;
                    }
                }
            }
            catch (WebException ex)
            {
                log.Error("Post数据出错:" + ex.Message);
                return "";
            }
        }
        #endregion
        public string md5Encript(String str) {
            MD5 md5 = new MD5CryptoServiceProvider();
            byte[] data = Encoding.UTF8.GetBytes(str);
            byte[] result = md5.ComputeHash(data);
            String md5Str = BitConverter.ToString(result).Replace("-","").ToLower();
            return md5Str;

        }
        /// <summary>
        /// 返回13位整数
        /// </summary>
        /// <param name="dateTime"></param>
        /// <returns></returns>
        public long getTimeStamp(DateTime dateTime) {
            return (long)(dateTime.ToUniversalTime() - timeStampStartTime).TotalMilliseconds;
        
        }
        public long getTimeStamp10(DateTime dateTime)
        {
            return (long)(dateTime.ToUniversalTime() - timeStampStartTime).TotalSeconds;

        }

        class Result {
            public String state { get; set; }
            public String data { get; set; }
            public String msg { get; set; }


        }
      
        class reResult {
            public String execCode { get; set; }
            public String execMsg { get; set; }
            public String errCode { get; set; }

        }



    }


}


       

     
    
